using System;

namespace MDIApp.Syntax
{
	/// <summary>
	/// create log file
	/// </summary>
	public class Log
	{
		private System.IO.StreamWriter log;

		public Log()
		{
		}

		public void BeginLog()
		{
			this.log = System.IO.File.AppendText("log.html");	
			this.log.WriteLine("<html>");
			this.log.WriteLine("<body>");
			this.log.Flush();
			this.log.Close();
		}

		public void EndLog()
		{
			this.log = System.IO.File.AppendText("log.html");	
			this.log.WriteLine("</body>");
			this.log.WriteLine("</html>");
			this.log.Flush();
			this.log.Close();
		}

		private string GetNameState(int num) 
		{
			string str_cut = "";
			switch (num) 
			{
				case 0: str_cut = "\"\"";                               break;
				case 1:	str_cut = "\" \"";                      break;
				case 2:	str_cut = "\" \"";                  break;
				case 3:	str_cut = "\"   \""; break;
				case 4:	str_cut = "\" \"";                   break;
				case 5:	str_cut = "\"\"";	                               break;
				case 6:  str_cut = "\"\"";                                  break;
				case 7:	 str_cut = "\"\"";                                    break;
				default:													       break;
			}
			str_cut +=  " (y0 = " + (num) + ")";  
			return str_cut;
		}
		public void StartAuto() 
		{
			this.log = System.IO.File.AppendText("log.html");	
			this.log.WriteLine("<p><font face=Courier New Size=3 color=f0429CA>     .</font><br>");
			this.log.Flush();
			this.log.Close();
		}

		public void FinishAuto()
		{
			this.log = System.IO.File.AppendText("log.html");	
			this.log.WriteLine("<font face=Courier New Size=3 color=f0429CA>     .</font></p>");
			this.log.Flush();
			this.log.Close();
		}

		public void PrintTime()
		{
			this.log.WriteLine("[" + System.DateTime.Now.Hour + ":"  + System.DateTime.Now.Minute + ":" + System.DateTime.Now.Second + "]");
		}

		public void PrintLog(int cur, int old)
		{
			this.log = System.IO.File.AppendText("log.html");	
			string str_cur, str_old;
			str_cur = this.GetNameState(cur);
			str_old = this.GetNameState(old);
			this.log.WriteLine("<font face=Courier New size=2>");
			this.PrintTime();
			if (cur != old)
				this.log.WriteLine("     <font color=0429CA>" + str_old + "</font>   <font color=0429CA>" + str_cur + "</font>.<br><br>");
			else this.log.WriteLine("     <font color=0429CA>" + str_cur + "</font>.<br><br>");
			this.log.WriteLine("</font>");
			this.log.Flush();
			this.log.Close();
		}

		public void PrintXLog(int x) 
		{
			string comment = "";
			switch (x) 
			{
				case 1:  comment = "x1() -   \"/\".<br>"; break;
				case 2:  comment = "x2() -   \"*\".<br>"; break;
				case 3:  comment = "x3() -   .<br>"; break;
				case 4:  comment = "x4() -   \"\\n\".<br>"; break;
				case 5:  comment = "x5() -   \"$\".<br>"; break;
				case 6:  comment = "x6() -   .<br>"; break;
				case 7:  comment = "x7() -      .<br>"; break;
				case 8:  comment = "x8() -     .<br>"; break;
				case 9:  comment = "x9() -        .<br>"; break;
				case 10: comment = "x10() -   .<br>"; break;
				case 11: comment = "x11() -     .<br>"; break;
				case 12: comment = "x12() -        .<br>"; break;
				default: break;
			}
			this.log = System.IO.File.AppendText("log.html");	
			this.log.WriteLine("<font face=Courier New size=2>");
			this.log.WriteLine("&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp " + comment);
			this.log.WriteLine("</font>");
			this.log.Flush();
			this.log.Close();
		}

		public void PrintZLog(int z)
		{
			string comment = "";
			switch (z) 
			{
				case 1: comment = "z1() -   .<br>"; break;
				case 2: comment = "z2() -    .<br>"; break;
				case 3: comment = "z3() -   .<br>"; break;
				case 4: comment = "z4() -     .<br>"; break;
				case 5: comment = "z5() -    ,     .<br>"; break;
				case 6: comment = "z6() -   .<br>"; break;
				case 7: comment = "z7() -    .<br>"; break;
				case 8: comment = "z8() -    ,   .<br>"; break;
				case 9: comment = "z9() -   .<br>"; break;
				case 10: comment = "z10() -   .<br>"; break;
				case 11: comment = "z11() -      .<br>"; break;
				case 12: comment = "z12() -   .<br>"; break;
				case 13: comment = "z13() -      .<br>"; break;
				default: break;
			}
			this.log = System.IO.File.AppendText("log.html");	
			this.log.WriteLine("<font face=Courier New size=2>");
			this.log.WriteLine("&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp " + comment);
			this.log.WriteLine("</font>");
			this.log.Flush();
			this.log.Close();
		}
	}
}
