using System;

namespace MDIApp.Syntax
{
    /// <summary>
    /// 
    /// </summary>
    public class Parser
    {
        readonly public GroupList language;
		private int y0; //  
        private int i;  //   
		private string text;

		private int begin;
		private int end;

		BlockList result;
		public Log log;

		
        public Parser(ref GroupList language)
        {
            this.language = language;
			this.y0 = 0;
			this.i = 0;
			this.text = "";
			this.begin = -1;
			this.end = -1;
			this.result = new BlockList();
			this.log = new Log();
			this.language.LoadFromFile("wordfile.txt");
        }


        public BlockList Parse(string txt)
        {
			int st_old = 0;

	
			this.result = new BlockList();
				
            if (txt == "") 
            {
                result.Add(new Block());
                return result;
            }
    		
			log.StartAuto();
			this.y0 = 1;
			this.text = txt;
			this.begin = 0;
			this.end = 0;
	
			for (int j = 0; j < this.text.Length; j++) 
			{
				
				this.i = j;
				switch(y0) 
				{
	//  
				  case 1:
				   if (x1() && !x3())     {					 y0 = 2;}
				   else if (x5() && !x3()) { z1(); z8();              y0 = 6;}
				   else if (x5() && x3())  { z8(); z6();              y0 = 9;}
				   else if (x10() && x3()) { z1(); z8(); z10();       y0 = 9;} 
    			   else if (x10() && !x3()){ z1(); z8();              y0 = 8;}
			   	   else if (!x6() && !x3()){ z1(); z8();              y0 = 7;}
				   else if (!x6() && x3()) { z1(); z8();              y0 = 9;}
				   else if (x3())		   { z1();				 y0 = 9;}
				   break;

				  //   
				  case 2:
				   if (x2() && !x3())      { z4(); z5();              y0 = 3;}
				   else if (x2() && x3())  { z4(); z5(); z3();        y0 = 9;}
				   else if (x1() && !x3()) { z4(); z5();              y0 = 5;}
				   else if (x1() && x3())  { z4(); z5(); z3();        y0 = 9;}
				   else if (x3())		   { z1();				 y0 = 9;}
				   else	  		   {                           y0 = 1;}
				   break;

				  // 
				  case 3:
				   if (x2() && !x3())  	   {					 y0 = 4;}
				   if (x3())		   { z3();				 y0 = 9;}
				   break;

				  //    
				  case 4:
				    if (x3())  		   { z3();				 y0 = 9;}				    if (x1() && !x3())	   { z3(); z2();		       y0 = 1;}
				    else 			   {					 y0 = 3;}
				    break;
				  


//  
				  case 5:
				   if (x4() && !x3())       { z3(); z2();            y0 = 1;}
				   if (x3())		    { z3();                   y0 = 9;}       
                        break;

   				  // 
				  case 6:
				   if (x7() && (x3() || x6())) { z7(); z8();         y0 = 1;}
				   else if (x6() && !x3())	 { z6(); z8();          y0 = 1;}
				   else if (x6() && x3())      { z6(); z8(); z3();   y0 = 9;}				   else if (x3())		  	 { z6();                y0 = 9;}				   if (x1() && !x3())		 {		z2();	      y0 = 2;}
				   break;
				  
  // 
				  case 7:
				   if (x8() && x3())           { z9();  z2();         y0 = 1;}
				   else if (x9() && x6())      { z11(); z8(); z1();   y0 = 1;}
				   else if (x11() && x3())     { z12(); z2();         y0 = 1;}
				   else if (x12() && x6())     { z13(); z8(); z1();   y0 = 1;}
				   else if (x6() && x3())      { z1();  z2();         y0 = 9;}				   
				   else if (x6() && !x3())     { z1();  z2();         y0 = 1;}
				   else if (x3())              { z1();                y0 = 9;}				   if (x1() && !x3())	    	 {	    z2();		 y0 = 2;}
				   break;

				  // 
				  case 8:
                        if (!x10() && !x3())        { z10(); z8();         y0 = 1;}
				   if (!x10() && x3())         { z10(); z8(); z1();   y0 = 1;}
				   else if (x10() && x3())     { z10();               y0 = 9;}                        
           		   if (x1() && !x3())	    	 {	    z2();		 y0 = 2;}
   break;

				  //  
				  case 9:
					break;

				  default:
					break;
		}
				log.PrintLog(y0, st_old);
				st_old = y0;
			}
			log.FinishAuto();
 			#region  
            return result;
            #endregion 
        }
		

		
		#region x1:     "/"
		public bool x1()
		{
			if (this.text.Substring(this.i, 1) == "/") 
			{
				log.PrintXLog(1);
				return true;
			}
			else return false;
		}
		#endregion 

		#region x2:     "*"
		public bool x2()
		{
			if (this.text.Substring(this.i, 1) == "*") 
			{
				log.PrintXLog(2);
				return true;
			}
			
			else return false;
		}
		#endregion 
		
		#region x3:     
		public bool x3()
		{
			if (this.i == this.text.Length - 1)  
			{
				log.PrintXLog(3);
				return true;
			}
			else return false;
		}
		#endregion 

		#region x4:     "\n"
		public bool x4()
		{
			if (this.text.Substring(this.i, 1) == "\n") 
			{
				log.PrintXLog(4);
				return true;
			}
			else return false;
		}
		#endregion 

		#region x5:     "$"
		public bool x5()
		{
			if (this.text.Substring(this.i, 1) == "$")
			{
				log.PrintXLog(5);
				return true;
			}
			
			else return false;
		}
		#endregion 

		#region x6:     
		public bool x6()
		{
			if (language[4].Contains(this.text.Substring(this.i, 1))) 
			{
			}
			if (language[4].Contains(this.text.Substring(this.i, 1))) 
			{
				log.PrintXLog(6);
				return true;
			}
			
			else return false;
		}
		#endregion 

		#region x7:     keyword
		public bool x7()
		{
			if (this.begin >= this.i) return false;
			string txt = this.text.Substring(this.begin, this.i - this.begin + 1);
			if (language[5].Contains(txt)) 
			{
				log.PrintXLog(7);
				return true;
			}
			
			else return false;
		}
		#endregion 

		#region x8:     function
		public bool x8()
		{
		//	log_.WriteLine("whether it symbol is function");
		//	log_.Flush();
			if (this.begin >= this.i) return false;
			string txt = this.text.Substring(this.begin, this.i - this.begin + 1);
		//	log_.WriteLine(txt);
			if (language[10].Contains(txt)) 
			{
				log.PrintXLog(8);
				return true;
			}
			
			else return false;
		}
		#endregion 

		#region x9:     function   
		public bool x9()
		{
			if (this.begin >= this.i) return false;
			string txt = this.text.Substring(this.begin, this.i - this.begin);
			if (language[10].Contains(txt)) 
			{
				log.PrintXLog(9);
				return true;
			}
			
			else return false;
		}
		#endregion 

		#region x10:     number
		public bool x10()
		{
		//	log_.WriteLine(this.text.Substring(this.i, 1));
			if (language[3].Contains(this.text.Substring(this.i, 1))) 
			{
				log.PrintXLog(10);
				return true;
			}
			
			else return false;
		}
		#endregion 

		#region x11:     words
		public bool x11()
		{
	//		log_.WriteLine("whether it symbol is function");
	//		log_.Flush();
			if (this.begin >= this.i) return false;
			string txt = this.text.Substring(this.begin, this.i - this.begin + 1);
	//		log_.WriteLine(txt);
			if (language[6].Contains(txt)) 
			{
				log.PrintXLog(11);
				return true;
			}
			
			else return false;
		}
		#endregion 

		#region x12:     words   
		public bool x12()
		{
			if (this.begin >= this.i) return false;
			string txt = this.text.Substring(this.begin, this.i - this.begin);
			if (language[6].Contains(txt)) 
			{
				log.PrintXLog(12);
				return true;
			}
			
			else return false;
		}
		#endregion 

		#region z1:   
		public void z1()
		{
		//	log_.WriteLine("Create simple text block");
		//	log_.Flush();
				
			this.end = this.i + 1;
			if (this.begin != this.end)
				this.result.Add(new Block(this.begin, this.end, 1));
			log.PrintZLog(1);
		}
		#endregion 
	
		#region z2:    
		public void z2()
		{
			this.begin = this.i + 1;
			log.PrintZLog(2);
		}
		#endregion 

		#region z3:   
		public void z3()
		{
			this.end = this.i + 1;
		//	log_.WriteLine("Create comment block " + begin + " " + end + "");
		//	log_.Flush();
			result.Add(new Block(this.begin, this.end, 2));
			log.PrintZLog(3);
		}
		#endregion 
	
		#region z4:     
		public void z4()
		{
			this.end = this.i - 1;
		//	log_.WriteLine("Create text block " + begin + " " + end + "");
		//	log_.Flush();
			if (this.begin != this.end) 
				result.Add(new Block(this.begin, this.end, 1));
			log.PrintZLog(4);
		}
		#endregion 

		#region z5:    ,      
		public void z5()
		{
			this.begin = this.i - 1;
			log.PrintZLog(5);
		}
		#endregion

		#region z6:   
		public void z6()
		{
			this.end = this.i + 1;
		//	log_.WriteLine("Create variable block" + begin + " " + end + "");
		//	log_.Flush();
			result.Add(new Block(this.begin, this.end, 8));
			log.PrintZLog(6);
		}
		#endregion

		#region z7:   keyword
		public void z7()
		{
			this.end = this.i + 1;
			result.Add(new Block(this.begin, this.end, 5));
			log.PrintZLog(7);
		}
		#endregion

		#region z8:    ,   
		public void z8()
		{
			this.begin = this.i;
			log.PrintZLog(8);
		}
		#endregion

		#region z9:   function
		public void z9()
		{
			this.end = this.i + 1;
			result.Add(new Block(this.begin, this.end, 10));
			log.PrintZLog(9);
		}
		#endregion

		#region z10: p  number
		public void z10()
		{
		//	log_.WriteLine("Number");
			this.end = this.i + 1;
			result.Add(new Block(this.begin, this.end, 3));
			log.PrintZLog(10);
		}
		#endregion

		#region z11:   function   
		public void z11()
		{
			this.end = this.i;
			result.Add(new Block(this.begin, this.end, 10));
			log.PrintZLog(11);
		}
		#endregion

		#region z12:   words
		public void z12()
		{
			this.end = this.i + 1;
			result.Add(new Block(this.begin, this.end, 6));
			log.PrintZLog(12);
		}
		#endregion

		#region z13:   words   
		public void z13()
		{
			this.end = this.i;
			result.Add(new Block(this.begin, this.end, 6));
			log.PrintZLog(13);
		}
		#endregion

	}
}
